'Compilable Example:
#Compile Exe "gbanalyzer.exe"
#Dim All
%Unicode = 1
#Include "Win32API.inc"

#Resource Icon logo "images/logo.ico"
#Resource Icon xhelp "images/help.ico"
#Resource Icon xfolder "images/folder.ico"
#Resource Icon xsearchd "images/searchdnew.ico"
#Resource Icon xsearcht "images/searchtnew.ico"
#Resource Icon xsettings "images/settings.ico"
#Resource Icon xsingle "images/multiline.ico"
#Resource Icon xsearchall "images/searchall.ico"
#Resource Icon xfont "images/font.ico"

Enum Controls Singular
   IDC_StatusBar  = 500
   IDC_Label
   IDC_DeclareTerm
   IDC_TypeTerm
   IDC_Results
   IDC_SourcePath
   IDC_SelectPath
   IDC_Toolbar

   IDM_PBWin9
   IDM_PBWin10
   IDM_PBCC6
   IDM_PBCC5
   IDM_Roca
   IDM_SelectPBWin9
   IDM_SelectPBWin10
   IDM_SelectPBCC6
   IDM_SelectPBCC5
   IDM_SelectRoca
   IDM_Sep
   IDM_SavePath
   IDM_RestorePath
   IDM_OpenSource
   IDM_WholeWords
   IDM_Copy
   IDM_Cut
   IDM_Paste
   IDM_Delete
   IDM_Clear
   IDM_SelectAll
   IDM_View1D
   IDM_View3D
   IDM_View1T
   IDM_View3T
   IDM_RemoveComments
   IDM_Exit
   IDM_EditAllowed

   IDT_SelectFolder
   IDT_Build
   IDT_SearchD
   IDT_SearchT
   IDT_SearchAll
   IDT_Settings
   IDT_Multiline
   IDT_Font
   IDT_Help
End Enum

$MergeFile = "merged_includes.txt
$DeclareOneLine = "oneliner_declare.txt"
$DeclareMultiLine = "multiliner_declare.txt"
$TypeOneLine = "oneliner_type.txt
$TypeMultiLine = "multiliner_type.txt

Global hDlg,hToolbar,hImageList,hFolder,hSettings,hContext,hFont As Dword
Global hSourcePath, hDeclareTerm, hTypeTerm, ghHook, hViewAll,hSelectPaths As Dword
Global MultiLineDisplay, OldProc, SearchAll, FontSize, FontAttr, WholeWords, RemoveComments As Long
Global FontName, LastSearch, SourcePath, SavedPath, DeclareTerm As WStringZ * %Max_Path
Global TypeTerm, AllowedChars, PBWin10Path, PBWin9Path, PBCC6Path, PBCC5Path, RocaPath As WStringZ * %Max_Path

Function PBMain() As Long
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
         Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop

   Dialog New Pixels, 0, "gbAnalyzer v2.01",300,300,460,400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"

   Control Add Label, hDlg, %IDC_Label, "Source Folder:", 10,55,120,20, %SS_Notify
   Control Add Label, hDlg, %IDC_Label, "Declare Search Term:", 10,80,120,20
   Control Add Label, hDlg, %IDC_Label, "Type Search Term:", 10,105,120,20

   Control Add TextBox, hDlg, %IDC_SourcePath, Exe.Path$, 130,50,250,20
   Control Handle hDlg, %IDC_SourcePath To hSourcePath
   Control Add TextBox, hDlg, %IDC_DeclareTerm, "", 130,80,250,20
   Control Handle hDlg, %IDC_DeclareTerm To hDeclareTerm
   Control Add TextBox, hDlg, %IDC_TypeTerm, "", 130,105,250,20
   Control Handle hDlg, %IDC_TypeTerm To hTypeTerm

   Control Add TextBox, hDlg, %IDC_Results, "", 10,135,440,300, style&, %WS_Ex_ClientEdge Or %WS_Ex_Left

   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local i,w,h As Long
   Local temp$, P As ToolTipText Ptr, nmtb As TBNotify Ptr, rc As Rect
   Select Case Cb.Msg
      Case %WM_InitDialog
         CreateSubFolders
         BuildAcceleratorTable
         Settings_ini "get
         Font New FontName, FontSize, FontAttr To hFont
         Control Set Font hDlg, %IDC_Results, hFont
         CreateToolbar
         SetMenuStatus
         Control Set Text hDlg, %IDC_DeclareTerm, DeclareTerm
         Control Set Text hDlg, %IDC_TypeTerm, TypeTerm
         Control Set Text hDlg, %IDC_SourcePath, SourcePath
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Results), %GWL_WndProc, CodePtr(NewProc))  'subclass
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_SourcePath), %GWL_WndProc, CodePtr(NewProc))  'subclass
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_DeclareTerm), %GWL_WndProc, CodePtr(NewProc))  'subclass
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_TypeTerm), %GWL_WndProc, CodePtr(NewProc))  'subclass
         Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Source Folder: " + SourcePath
         RestoreSession

      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_Results, w-20, h-160
         Control Set Size hDlg, %IDC_SourcePath, w-140, 20
         Control Set Size hDlg, %IDC_DeclareTerm, w-140, 20
         Control Set Size hDlg, %IDC_TypeTerm, w-140, 20

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_SelectFolder
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hFolder, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_SelectFolder To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
           End Select

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_SelectFolder
               SourcePath = SelectFolder("Select Source Folder"+$CrLf+SourcePath,SourcePath)
               Control Set Text hDlg, %IDC_SourcePath, SourcePath
            Case %IDM_PBWin10
               SourcePath = PBWin10Path
               Control Set Text hDlg, %IDC_SourcePath, SourcePath
            Case %IDM_PBWin9
               SourcePath = PBWin9Path
               Control Set Text hDlg, %IDC_SourcePath, SourcePath
            Case %IDM_PBCC6
               SourcePath = PBCC6Path
               Control Set Text hDlg, %IDC_SourcePath, SourcePath
            Case %IDM_PBCC5
               SourcePath = PBCC5Path
               Control Set Text hDlg, %IDC_SourcePath, SourcePath
            Case %IDM_Roca
               SourcePath = RocaPath
               Control Set Text hDlg, %IDC_SourcePath, SourcePath

            Case %IDM_SavePath
               Control Get Text hDlg, %IDC_SourcePath To SavedPath
            Case %IDM_RestorePath
               SourcePath = SavedPath
               Control Set Text hDlg, %IDC_SourcePath, SourcePath

            Case %IDT_Build
               If Cb.CtlMsg = %BN_Clicked Then
                  Control Get Text hdlg, %IDC_SourcePath To SourcePath
                  If Right$(Trim$(SourcePath),1) <> "\" Then SourcePath = Trim$(SourcePath) + "\"
                  If IsFolder(SourcePath) Then
                     BuildMergeFile
                  Else
                     Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Invalid folder specified!"
                     Beep
                  End If
               End If

            Case %IDT_SearchD  : LastSearch = "D" : SearchD
            Case %IDT_SearchT  : LastSearch = "T" : SearchT

            Case %IDT_Font
               SelectMainFont
               Font New FontName, FontSize, FontAttr To hFont
               Control Set Font hDlg, %IDC_Results, hFont

            Case %IDT_SearchAll
               SearchAll = SearchAll Xor 1
               SetMenuStatus

            Case %IDT_Multiline
               MultiLineDisplay = MultiLineDisplay Xor 1
               SetMenuStatus
               If Len(LastSearch) Then
                  If LastSearch = "D" Then SearchD Else SearchT
               End If

            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbanalyzer.htm"
                 i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_OpenSource, %IDT_Settings
               Control Get Text hDlg, %IDC_SourcePath To SourcePath
               ShellExecute(hDlg, "Open", (SourcePath), $Nul, $Nul, %SW_Restore)

            Case %IDM_WholeWords
               WholeWords = WholeWords Xor 1
               SetMenuStatus

            Case %IdOk
               Select Case GetFocus
                  Case hSourcePath
                     SourcePath = SelectFolder("Select Source Folder"+$CrLf+SourcePath, SourcePath)
                     Control Set Text hDlg, %IDC_SourcePath, SourcePath
                  Case hDeclareTerm : SearchD
                  Case hTypeTerm    : SearchT
               End Select

            Case %IDC_Label
               Control Get Text hDlg, %IDC_SourcePath To SourcePath
               ShellExecute(hDlg, "Open", (SourcePath), $Nul, $Nul, %SW_Restore)

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0
            Case %IDM_Clear   : SendMessage GetFocus, %WM_SetText, 0, 0
            Case %IDM_SelectAll : SendMessage GetFocus, %EM_SetSel, 0, -1

            Case %IDM_RemoveComments
               RemoveComments = RemoveComments Xor 1
               SetMenuStatus

            Case %IDM_EditAllowed
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcChar), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Edit Allowed Character List", "Allowed Character List", AllowedChars,w+40,h+150)
               If Len(temp$) Then AllowedChars = temp$

            Case %IDM_Exit
               Dialog End hDlg

            Case %IDM_View1D
               i = ShellExecute(hDlg, "Open", (Exe.Path$ + SubFolder + $DeclareOneLine), $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_View3D
               i = ShellExecute(hDlg, "Open", (Exe.Path$ + SubFolder + $DeclareMultiLine), $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_View1T
               i = ShellExecute(hDlg, "Open", (Exe.Path$ + SubFolder + $TypeOneLine), $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_View3T
               i = ShellExecute(hDlg, "Open", (Exe.Path$ + SubFolder + $TypeMultiLine), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_SelectPBWin10 : PBWin10Path = SelectFolder("Select PBWin10 Include Folder" + $CrLf + PBWin10Path, PBWin10Path)
            Case %IDM_SelectPBWin9  : PBWin9Path = SelectFolder("Select PBWin9 Include Folder" + $CrLf + PBWin9Path, PBWin9Path)
            Case %IDM_SelectPBCC6   : PBCC6Path = SelectFolder("Select PBCC6 Include Folder" + $CrLf + PBCC6Path, PBCC6Path)
            Case %IDM_SelectPBCC5   : PBCC5Path = SelectFolder("Select PBCC5 Include Folder" + $CrLf + PBCC5Path, PBCC5Path)
            Case %IDM_SelectRoca    : RocaPath = SelectFolder("Select Roca Include Folder" + $CrLf + RocaPath, RocaPath)
         End Select
      Case %WM_Destroy
         Control Get Text hDlg, %IDC_DeclareTerm To DeclareTerm
         Control Get Text hDlg, %IDC_TypeTerm To TypeTerm
         Settings_ini "save
         SaveSession
         SetWindowLong GetDlgItem(hDlg, %IDC_Results), %GWL_WNDPROC, OldProc   'un-subclass
         SetWindowLong GetDlgItem(hDlg, %IDC_SourcePath), %GWL_WNDPROC, OldProc   'un-subclass
         SetWindowLong GetDlgItem(hDlg, %IDC_DeclareTerm), %GWL_WNDPROC, OldProc   'un-subclass
         SetWindowLong GetDlgItem(hDlg, %IDC_TypeTerm), %GWL_WNDPROC, OldProc   'un-subclass

   End Select
End Function

Sub CreateToolbar
    ImageList New Icon 24,24,24,20 To hImageList
    ImageList Add Icon hImageList, "logo"        '1
    ImageList Add Icon hImageList, "xhelp"       '2
    ImageList Add Icon hImageList, "xfolder"     '3
    ImageList Add Icon hImageList, "xsearchd"    '4
    ImageList Add Icon hImageList, "xsearcht"    '5
    ImageList Add Icon hImageList, "xsettings"   '6
    ImageList Add Icon hImageList, "xsingle"     '7
    ImageList Add Icon hImageList, "xsearchall"  '8
    ImageList Add Icon hImageList, "xfont"       '9

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_SelectFolder,  %TbStyle_Button Or %TbStyle_DropDown, "Folder"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Build,  %TbStyle_Button, "Build"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_SearchD,  %TbStyle_Button, "Declare"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_SearchT,  %TbStyle_Button, "Type"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_SearchAll,  %TbStyle_Check, "Search All"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_MultiLine,  %TbStyle_Check, "MultiLine"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Help,  %TbStyle_Check, "Help"

   Menu New PopUp To hFolder
   Menu Add String, hFolder, "PBWin10",  %IDM_PBWin10,  %MF_Enabled
   Menu Add String, hFolder, "PBWin9",  %IDM_PBWin9,  %MF_Enabled
   Menu Add String, hFolder, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hFolder, "Roca",  %IDM_Roca,  %MF_Enabled
   Menu Add String, hFolder, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hFolder, "PBCC6",  %IDM_PBCC6,  %MF_Enabled
   Menu Add String, hFolder, "PBCC5",  %IDM_PBCC5,  %MF_Enabled
   Menu Add String, hFolder, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hFolder, "Save Path",  %IDM_SavePath,  %MF_Enabled
   Menu Add String, hFolder, "Restore Path",  %IDM_RestorePath,  %MF_Enabled

   Menu New PopUp To hViewAll
   Menu Add String, hViewAll, "Declares (Single Line)",  %IDM_View1D,  %MF_Enabled
   Menu Add String, hViewAll, "Declares (Multi-Line)",  %IDM_View3D,  %MF_Enabled
   Menu Add String, hViewAll, "-", 0, 0
   Menu Add String, hViewAll, "Types (Single Line)",  %IDM_View1T,  %MF_Enabled
   Menu Add String, hViewAll, "Types (Multi-Line)",  %IDM_View3T,  %MF_Enabled

   Menu New PopUp To hSelectPaths
   Menu Add String, hSelectPaths, "PBWin10 Path",  %IDM_SelectPBWin10,  %MF_Enabled
   Menu Add String, hSelectPaths, "PBWin9 Path",  %IDM_SelectPBWin9,  %MF_Enabled
   Menu Add String, hSelectPaths, "Roca Path",  %IDM_SelectRoca,  %MF_Enabled
   Menu Add String, hSelectPaths, "PBCC6 Path",  %IDM_SelectPBCC6,  %MF_Enabled
   Menu Add String, hSelectPaths, "PBCC5 Path",  %IDM_SelectPBCC5,  %MF_Enabled

   Menu New PopUp To hSettings
   Menu Add String, hSettings, "Open Source Folder",  %IDM_OpenSource,  %MF_Enabled
   Menu Add String, hSettings, "Edit Word Characters",  %IDM_EditAllowed,  %MF_Enabled
   Menu Add PopUp,  hSettings, "View All", hViewAll, %MF_Enabled
   Menu Add PopUp,  hSettings, "Select Paths", hSelectPaths, %MF_Enabled
   Menu Add String, hSettings, "-", 0, 0
   Menu Add String, hSettings, "Whole Words",  %IDM_WholeWords,  %MF_Enabled
   Menu Add String, hSettings, "Remove Comments",  %IDM_RemoveComments,  %MF_Enabled

   Menu New PopUp To hContext
   Menu Add String, hContext, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContext, "Select All",   %IDM_SelectAll,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContext, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Clear", %IDM_Clear,  %MF_Enabled

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_SelectFolder: Function = "Select Source Folderr"
      Case %IDT_Build       : Function = "Build Merge File"
      Case %IDT_SearchD     : Function = "Search for Matching Declares"
      Case %IDT_SearchT     : Function = "Search For Matching Types"
      Case %IDT_SearchAll   : Function = "Search Complete Construct (Declare or Type) vs Name Only"
      Case %IDT_MultiLine   : Function = "Multi-Line Display"
      Case %IDT_Font        : Function = "Select Font"
      Case %IDT_Settings    : Function = "Open Source Folder"
      Case %IDT_Help        : Function = "Open Online Help"
   End Select
End Function

Sub Settings_INI(Task$)
   Local x As Long, y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + "support_files\gbanalyzer.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "525", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "SourcePath", Exe.Path$, SourcePath, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SavedPath", Exe.Path$, SavedPath, %Max_Path, INIFileName
      Getprivateprofilestring "All", "DeclareTerm", "SendMessage", DeclareTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TypeTerm", "Rect", TypeTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "LastSearch", "", LastSearch, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Courier New", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "AllowedChars", Chr$(37,45,46,58,95,48 To 57,65 To 90,97 To 122), AllowedChars, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PBWin10Path", "c:\pbwin10\winapi\", PBWin10Path, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PBWin9Path", "c:\pbwin90\winapi\", PBWin9Path, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PBCC6Path", Exe.Path$, PBCC6Path, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PBCC5Path", Exe.Path$, PBCC5Path, %Max_Path, INIFileName
      Getprivateprofilestring "All", "RocaPath", "c:\pbwin10\roca\", RocaPath, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "MultiLineDisplay", "0", temp, %Max_Path, INIFileName:  MultiLineDisplay = Val(temp)
      Getprivateprofilestring "All", "SearchAll", "0", temp, %Max_Path, INIFileName:  SearchAll = Val(temp)
      Getprivateprofilestring "All", "FontSize", "10",  temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0",  temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "WholeWords", "0",  temp, %Max_Path, INIFileName:  WholeWords = Val(temp)
      Getprivateprofilestring "All", "RemoveComments", "1",  temp, %Max_Path, INIFileName:  RemoveComments = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "SourcePath", (SourcePath), INIFileName
      WritePrivateProfileString "All", "SavedPath", (SavedPath), INIFileName
      WritePrivateProfileString "All", "DeclareTerm", (DeclareTerm), INIFileName
      WritePrivateProfileString "All", "TypeTerm", (TypeTerm), INIFileName
      WritePrivateProfileString "All", "LastSearch", (LastSearch), INIFileName
      WritePrivateProfileString "All", "FontName",fontName, INIFileName
      WritePrivateProfileString "All", "AllowedChars",AllowedChars, INIFileName
      WritePrivateProfileString "All", "PBWin10Path",PBWin10Path, INIFileName
      WritePrivateProfileString "All", "PBWin9Path",PBWin9Path, INIFileName
      WritePrivateProfileString "All", "PBCC6Path",PBCC6Path, INIFileName
      WritePrivateProfileString "All", "PBCC5Path",PBCC5Path, INIFileName
      WritePrivateProfileString "All", "RocaPath",RocaPath, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "MultiLineDisplay", (Str$(MultiLineDisplay)), INIFileName
      WritePrivateProfileString "All", "SearchAll", (Str$(SearchAll)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "WholeWords", (Str$(WholeWords)), INIFileName
      WritePrivateProfileString "All", "RemoveComments", (Str$(RemoveComments)), INIFileName

   End If
End Sub

Sub BuildMergeFile
   Local i,iPos,iCount,DeclareCount,TypeCount,Flag As Long, temp$
   MousePtr 11
    '====== Create MergeFile ===============================================================================
    Shell "cmd /C copy " + SourcePath + "*.inc" + $Spc + Exe.Path$ + SubFolder + $MergeFile + " /b", 0
    If IsFile(Exe.Path$ + "gbanalyzer.bit") And SubFolder = "pbwin10\" Then
       Open Exe.Path$ + "gbanalyzer.bit" For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       'add built in types
       Open Exe.Path$ + SubFolder + $MergeFile For Append As #1
       Print #1, temp$
       Close #1
    End If
    '====== Create Declare Files ===============================================================================
    'load $MergeFile into array
    Open Exe.Path$ + SubFolder + $MergeFile For Input As #1
    FileScan #1, Records To iCount
    Dim D(iCount-1) As String
    Line Input #1, D() To iCount
    Close #1
    'count how many Declares and Types there are
    For i = 0 To UBound(D)
       If LCase$(Left$(D(i),7)) = "declare" Then Incr DeclareCount
       If LCase$(Left$(D(i),4)) = "type" Then Incr TypeCount
    Next i
    'load $MergeFile into array
    Open Exe.Path$ + SubFolder + $MergeFile For Input As #1
    FileScan #1, Records To iCount
    ReDim D(iCount-1)
    Line Input #1, D() To iCount
    Close #1
    'remove comments at end of line
    If RemoveComments Then
       For i = 0 To UBound(D)
          iPos = InStr(-1,D(i),"'")
          While iPos
             D(i) = Left$(D(i),iPos-1)
             iPos = InStr(-1,D(i),"'")                  'some Include lines have 2+ ' in them
          Wend
       Next i
    End If
    'trim lines
    For i = 0 To UBound(D)
       D(i) = Trim$(D(i))
    Next i
    'merge into string
    temp$ = Join$(D(),$CrLf)
    'merge all _ lines
    Replace "_" + $CrLf With $Spc In temp$
    temp$ = Shrink$(temp$)
    'rebuild array
    ReDim D(ParseCount(temp$,$CrLf)-1)
    Parse temp$, D(), $CrLf

    'Build Type Files
    Open Exe.Path$ + SubFolder + $TypeOneLine For Output As #1
    Open Exe.Path$ + SubFolder + $TypeMultiLine For Output As #2
    For i = 0 To UBound(D)
       If Len(Trim$(D(i))) = 0 Then Iterate For
       If LCase$(Left$(D(i),4)) = "type" Then
          Print #1, D(i);
          Print #2, D(i)
          Flag = 1
       ElseIf LCase$(Left$(D(i),8)) = "end type" Then
          Print #1, " ,, " + D(i)
          Print #2, D(i) + $CrLf
          Flag = 0
       Else
          If Flag = 1 Then
            Print #1, " , " + Trim$(D(i));
            Print #2, Space$(4) + D(i)
            End If
       End If
    Next i
    Close #1 : Close #2

    'Build Declare Files
    Array Sort D() ,Collate UCase
    Open Exe.Path$ + SubFolder + $DeclareOneLine For Output As #1
    Open Exe.Path$ + SubFolder + $DeclareMultiLine For Output As #2
    For i = 0 To UBound(D)
       If LCase$(Left$(D(i),7)) = "declare" Then
          Print #1, D(i)
          temp$ = ConvertToMultiLineD(D(i))
          Print #2, temp$ + $CrLf
       End If
    Next i
    Close #1 : Close #2

    'load multline declare file into array
    Open Exe.Path$ + SubFolder + $DeclareMultiLine For Input As #1
    FileScan #1, Records To iCount
    ReDim D(iCount-1)
    Line Input #1, D() To iCount
    Close #1
    'pretty up the multiline declare file
    For i = 0 To UBound(D)
       D(i) = Trim$(D(i))
       If LCase$(Left$(D(i),7)) = "declare" Then
          'nothing
       Else
          D(i) = Space$(4) + D(i)
       End If
    Next i
    'write the results
    Open Exe.Path$ + SubFolder + $DeclareMultiLine For Output As #1
    Print #1, Join$(D(),$CrLf)
    Close #1
    MousePtr 1
    Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Build Complete!  " + Str$(DeclareCount) + " Declares" _  '9298
                                                   + Str$(TypeCount) + " Types"
End Sub

Sub SetMenuStatus
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_MultiLine, %TBState_Checked * MultiLineDisplay Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchAll, %TBState_Checked * SearchAll Or %TBState_Enabled
   'Popup menus
   Menu Set State hSettings, ByCmd %IDM_WholeWords, WholeWords * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hSettings, ByCmd %IDM_RemoveComments, RemoveComments * (%MFS_Checked Or %MFS_Enabled)
End Sub

Function SelectFolder(title$, ByVal startPath$) As String
   Local flags&, xfolder$
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain
   Display Browse  hDlg, 100, 100, title$, startpath$, flags& To xfolder$   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(xfolder$) Then Function = xfolder$ Else Function = startPath$
End Function

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub SearchD
   Local i, iCount As Long, sTerm$, temp$, sMain$
   Control Get Text hDlg, %IDC_DeclareTerm To sTerm$
   sTerm$ = LCase$(sTerm)
   If Len(Trim$(sTerm)) = 0 Then Beep : Exit Sub
   'load $DeclareOneLine into array
   Open Exe.Path$ + SubFolder + $DeclareOneLine For Input As #1
   FileScan #1, Records To iCount
   Dim D(iCount-1) As String
   Line Input #1, D() To iCount
   Close #1
   'search array
   iCount = 0
   For i = 0 To UBound(D)
      If SearchAll Then
         sMain$ = LCase$(D(i))
      Else
         sMain$ = LCase$(Parse$(D(i),$Spc,3))
      End If
      If InStrWholeWord(sMain$, sTerm$) Then
         temp$ = temp$ + $CrLf + IIf$(MultiLineDisplay, ConvertToMultiLineD(D(i)), D(i))
         Incr iCount
      End If
   Next i
   Control Set Text hDlg, %IDC_Results, LTrim$(temp$, $CrLf)
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Matches: " + Str$(iCount)
End Sub

Sub SearchT
   Local i, iCount As Long, sTerm$, temp$, sMain$
   Control Get Text hDlg, %IDC_TypeTerm To sTerm$
   sTerm$ = LCase$(sTerm)
   If Len(Trim$(sTerm)) = 0 Then Beep : Exit Sub
   'load $DeclareOneLine into array
   Open Exe.Path$ + SubFolder + $TypeOneLine For Input As #1
   FileScan #1, Records To iCount
   Dim D(iCount-1) As String
   Line Input #1, D() To iCount
   Close #1
   iCount = 0
   'sort Array
    Array Sort D() ,Collate UCase
   'search array
   For i = 0 To UBound(D)
      If SearchAll Then
         sMain$ = LCase$(D(i))
      Else
         sMain$ = LCase$(Parse$(D(i),$Spc,2))
      End If
      If InStrWholeWord(sMain$, sTerm$) Then
         temp$ = temp$ + $CrLf + IIf$(MultiLineDisplay, ConvertToMultiLineT(D(i)), D(i))
         Incr iCount
      End If
   Next i
   Control Set Text hDlg, %IDC_Results, LTrim$(temp$,$CrLf)
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Matches: " + Str$(iCount)
End Sub

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
'   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub SaveSession
   Local temp$
   Control Get Text hDlg, %IDC_Results To temp$
   Open Exe.Path$ + "support_files\session.txt" For Output As #1
   Print #1, temp$
   Close #1
End Sub

Sub RestoreSession
   Local temp$
   If IsFile(Exe.Path$ + "support_files\session.txt") Then
      Open Exe.Path$ + "support_files\session.txt" For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
      Control Set Text hDlg, %IDC_Results, temp$
   End If
End Sub

Function InstrWholeWord(smain$,sterm$) As Long
    Local iPos,FlagLeft,FlagRight As Long, rChar$, lChar$

    'find sterm$ (not the whole word version)
    iPos = 1 : iPos = InStr(iPos, smain$, sterm$)
    If WholeWords=0 Then Function = iPos : Exit Function

    Do While iPos
        FlagLeft = %False : FlagRight = %False
        'check left side
        If iPos = 1 Then
            FlagLeft = %True                   'flush with left side of line
        Else
            lChar$ = Mid$(smain$,iPos-1,1)
            FlagLeft = IsTrue(Verify(lChar$, AllowedChars))
        End If
        'check right side
        If iPos = Len(smain$)-Len(sTerm$)+1 Then
            FlagRight = %True                 'flush with right side of line
        Else
            rChar$ = Mid$(smain$,iPos + Len(sterm$),1)
            FlagRight = IsTrue(Verify(rChar$, AllowedChars))
        End If
        'Done?
        If FlagLeft And FlagRight Then Exit Do
        iPos = InStr(iPos+Len(sterm$), smain$, sterm$)
    Loop
    Function = iPos
End Function

Function ConvertToMultiLineT(ByVal temp$) As String
   Replace ",, " With $CrLf In temp$
   Replace "," With $CrLf + Space$(4) In temp$
   Function = $CrLf + temp$
End Function

Function ConvertToMultiLineD(ByVal temp$) As String
   If InStr(temp$,"()") = 0 Then Replace "(" With "( _" + $CrLf + Space$(4) In temp$
   Replace ")" With " _" + $CrLf + Space$(4) + ")" In temp$
   Replace "," With " _" + $CrLf + Space$(3) In temp$
   Function = $CrLf + temp$
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(3)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd   = %IDT_SearchD       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDT_SearchT       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_X  : ac(c).cmd   = %IDM_Exit          : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function InputBoxProcChar(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
'      If UCase$(szTemp) = "BUTTON" Then @cst.cx = @cst20                           'prompt
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 580                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.cy = 20                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 560 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 675 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Function NewTBProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   'gets control id each time the subclassing procedure is called
   Select Case Msg
      Case %WM_ContextMenu
         Local Ctl As Dword
         Window Get Id hWnd To Ctl
         MsgBox Str$(Ctl)
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "support_files") = %False Then MkDir Exe.Path$ + "support_files"
   If IsFolder (Exe.Path$ + "pbwin10") = %False Then MkDir Exe.Path$ + "pbwin10"
   If IsFolder (Exe.Path$ + "pbwin9") = %False Then MkDir Exe.Path$ + "pbwin9"
   If IsFolder (Exe.Path$ + "pbcc6") = %False Then MkDir Exe.Path$ + "pbcc6"
   If IsFolder (Exe.Path$ + "pbcc5") = %False Then MkDir Exe.Path$ + "pbcc5"
   If IsFolder (Exe.Path$ + "roca") = %False Then MkDir Exe.Path$ + "roca"
   If IsFolder (Exe.Path$ + "non_standard_folder") = %False Then MkDir Exe.Path$ + "nonstandard_folder"
End Sub

Function SubFolder() As String
   'make sure everyone has the \
   If Right$(Trim$(PBWin10Path),1) <> "\" Then PBWin10Path = Trim$(PBWin10Path) + "\"
   If Right$(Trim$(PBWin9Path),1)  <> "\" Then PBWin9Path  = Trim$(PBWin9Path) + "\"
   If Right$(Trim$(PBCC6Path),1)   <> "\" Then PBCC6Path   = Trim$(PBCC6Path) + "\"
   If Right$(Trim$(PBCC5Path),1)   <> "\" Then PBCC5Path   = Trim$(PBCC5Path) + "\"
   If Right$(Trim$(RocaPath),1)    <> "\" Then RocaPath    = Trim$(RocaPath) + "\"
   Control Get Text hDlg, %IDC_SourcePath To SourcePath
   If Right$(Trim$(SourcePath),1)   <> "\" Then SourcePath = Trim$(SourcePath) + "\"
   'figure out which subfolder should be used
   Select Case LCase$(SourcePath)
      Case LCase$(PBWin10Path) : Function = "pbwin10\"
      Case LCase$(PBWin9Path)  : Function = "pbwin9\"
      Case LCase$(PBCC6Path)   : Function = "pbcc6\"
      Case LCase$(PBCC5Path)   : Function = "pbcc5\"
      Case LCase$(RocaPath)    : Function = "roca\"
      Case Else                : Function = "non_standard_folder\"
   End Select
End Function
